----------------------------------------------------
----	ANTI FLOOD SYSTEM BY BOOLEAN VALUE	----
----	    BUGS? CONTACT USGN 142503		----
----------------------------------------------------

--> INITIAL SETTINGS <--

if flood==nil then flood = {} end
function int(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end
flood.sayduration	= int(32,0)
flood.radduration	= int(32,0)
flood.dropduration	= int(32,0)
flood.savesay		= int(32,"empty")
flood.savesayy		= int(32,"")
flood.type		= int(32,0)
flood.hud		= int(32,"True")

--> CONFIGURATIONS <--

flood.saycooldown	= 7		-- GLOBAL SAY COOLDOWN IN SECONDS
flood.saytcooldown	= 6		-- TEAM SAY COOLDOWN IN SECONDS
flood.radcooldown	= 3		-- RADIO CHAT COOLDOWN IN SECONDS
flood.dropcooldown	= 3		-- WEAPON DROP COOLDOWN IN SECONDS
flood.maxlenght		= 25		-- MAX LETTERS YOU CAN SAY IN GLOBAL / TEAM SAY

--> HOOKS <--

addhook("second","flood.cooldown")
addhook("say","flood.hooksay")
addhook("sayteam","flood.hooksayteam")
addhook("radio","flood.hookradio")
addhook("drop","flood.hookdrop")
addhook("serveraction","flood.menuact")
addhook("menu","flood.menu")
addhook("spawn","flood.spawn")

--> SAY FLOOD TYPES <--
--(0) Allowed to say
--(1) Still in cooldown
--(2) Write too long
--(3) Write the same thing as before

--> FUNCTIONS <--

function flood.cooldown()
	for id = 1, 32 do
		if player(id,"exists") then
			if flood.sayduration[id]>0 then
				flood.sayduration[id]=flood.sayduration[id]-1
			end
			if flood.radduration[id]>0 then
				flood.radduration[id]=flood.radduration[id]-1
			end
			if flood.dropduration[id]>0 then
				flood.dropduration[id]=flood.dropduration[id]-1
			end
			if flood.hud[id]=="True" then
				parse('hudtxt2 '..tonumber(id)..' 2 "255255255Say cooldown : '..string.rep("|",flood.sayduration[id])..'" 458 26')
				parse('hudtxt2 '..tonumber(id)..' 3 "255255255Radio cooldown : '..string.rep("|",flood.radduration[id])..'" 458 42')
				parse('hudtxt2 '..tonumber(id)..' 4 "255255255Drop cooldown : '..string.rep("|",flood.dropduration[id])..'" 458 58')
			else
				parse('hudtxt2 '..tonumber(id)..' 1')
				parse('hudtxt2 '..tonumber(id)..' 2')
				parse('hudtxt2 '..tonumber(id)..' 3')
				parse('hudtxt2 '..tonumber(id)..' 4')
			end
		end
	end
end

function flood.hooksay(id,txt)
	if flood.savesay[id]==0 then flood.savesay[id]="empty" end
	t =string.lower(txt)
	if flood.savesayy[id]==t then
		flood.type[id]=3	-- WRITE MESSAGE SAME AS BEFORE (NEEDLESS/USELESS)
	elseif flood.savesayy[id]==string.reverse(t) then
		flood.type[id]=3	-- WRITE MESSAGE SAME AS BEFORE (NEEDLESS/USELESS)
	elseif string.len(txt)>flood.maxlenght then
		flood.type[id]=2	-- WRITE TOO LONG
		flood.savesay[id]=string.sub(txt,1,flood.maxlenght)
	elseif flood.sayduration[id]>=1 then
		flood.type[id]=1	-- STILL IN COOLDOWN
		flood.savesay[id]=txt
	elseif flood.sayduration[id]<=0 then
		flood.type[id]=0	-- NORMAL SAYING
		flood.savesayy[id]=t
	end
	if flood.type[id]==0 then
		flood.sayduration[id]=flood.saycooldown
	end
	if flood.type[id]==1 then
		msg2(id,"\169255000000You can say in "..flood.sayduration[id].." second again.")
		msg2(id,"\169255255255Saved in draft. Say /serveraction3 to load your msg.")
		return 1
	end
	if flood.type[id]==2 then
		msg2(id,"\169255000000Your message is too long. We saved your msg as long as possible.")
		msg2(id,"\169255255255Saved in draft. Say /serveraction3 to load your msg.")
		return 1
	end
	if flood.type[id]==3 then
		msg2(id,"\169255000000Please dont write same thing as you say before.")
		return 1
	end
end

function flood.hooksayteam(id,txt)
	if flood.savesay[id]==0 then flood.savesay[id]="empty" end
	t =string.lower(txt)
	if flood.savesayy[id]==t then
		flood.type[id]=3	-- WRITE MESSAGE SAME AS BEFORE (NEEDLESS/USELESS)
	elseif flood.savesayy[id]==string.reverse(t) then
		flood.type[id]=3	-- WRITE MESSAGE SAME AS BEFORE (NEEDLESS/USELESS)
	elseif string.len(txt)>flood.maxlenght then
		flood.type[id]=2	-- WRITE TOO LONG
		flood.savesay[id]=string.sub(txt,1,flood.maxlenght)
	elseif flood.sayduration[id]>=1 then
		flood.type[id]=1	-- STILL IN COOLDOWN
		flood.savesay[id]=txt
	elseif flood.sayduration[id]<=0 then
		flood.type[id]=0	-- NORMAL SAYING
		flood.savesayy[id]=t
	end
	if flood.type[id]==0 then
		flood.sayduration[id]=flood.saytcooldown
	end
	if flood.type[id]==1 then
		msg2(id,"\169255000000You can say in "..flood.sayduration[id].." second again.")
		msg2(id,"\169255255255Saved in draft. Say /serveraction3 to load your msg.")
		return 1
	end
	if flood.type[id]==2 then
		msg2(id,"\169255000000Your message is too long. We saved your msg as long as possible.")
		msg2(id,"\169255255255Saved in draft. Say /serveraction3 to load your msg.")
		return 1
	end
	if flood.type[id]==3 then
		msg2(id,"\169255000000Please dont write same thing as you say before.")
		return 1
	end
end

function flood.hookradio(id)
	if flood.radduration[id]<=0 then
		flood.radduration[id]=flood.radcooldown
	else
		msg2(id,"\169255000000Please do not flood / spam radio chat.")
		return 1
	end
end

function flood.menuact(id,action)
	if action==3 then
		if player(id,"health")>0 then
			if flood.savesay[id]=="empty" then				
				menu(id,"Draft & HUD,(Check draft|empty),(Sent draft|empty),,Toggle cooldown HUD|"..flood.hud[id]..",,Close")
			else
				menu(id,"Draft & HUD,Check Draft,Sent draft,,Toggle cooldown HUD|"..flood.hud[id]..",,Close")
			end
		end
	end
end

function flood.menu(id,title,button)
	if title=="Draft & HUD" then
		if button==1 then
			msg2(id,"\169200200200[Your draft]\169255255000 "..flood.savesay[id])
		end
		if button==2 then
			if flood.sayduration[id]<=0 then
				if player(id,"team")==1 then
					msg("\169200200200[Instant]\169255025000 "..player(id,"name")..": \169255220000"..flood.savesay[id])
				elseif player(id,"team")==2 then
					msg("\169200200200[Instant]\169050150255 "..player(id,"name")..": \169255220000"..flood.savesay[id])
				end
				flood.savesay[id]="empty"
			end
		end
		if button==4 then
			if flood.hud[id]=="True" then
				flood.hud[id]="False"
			else
				flood.hud[id]="True"
			end
		end
	end
end

function flood.hookdrop(id)
	if player(id,"health")>0 then
		if flood.dropduration[id]<=0 then
			flood.dropduration[id]=flood.dropcooldown
		else
			msg2(id,"\169255000000Please do not spam dropping items.")
			return 1
		end
	end
end

function flood.spawn(id)
	if flood.hud[id]=="True" then
		parse('hudtxt2 '..tonumber(id)..' 1 "255255255Press F4 to access HUD menu." 442 10')
		parse('hudtxtalphafade 0 1 10000 0.0')
	end
end
		